{$A+,B+,G-,I-,O-,V-,D-,L-,Q-,R-,S-,E-,N-   BP 7.0 options}
{2d bump lightning demo}

Program BumpLightning2d;  {26.09.97}
uses crt;

{optimized copy using 32-Bit-statements}
procedure DMove (var source, dest; count: word); assembler;

asm
           push ds           {ds save}
  db 66h;  xor  si, si       {clear esi}
           lds  si, source   {ds,esi = @source}
  db 66h;  xor  di, di       {clear edi}
           les  di, dest     {es,edi = @dest}
           cld               {clear direction flag}
  db 66h;  xor  cx, cx       {clear ecx}
           mov  cx, count    {ecx = count}
  db 66h;  rep  movsw        {copy with double word stepping}
           pop  ds           {ds restore}
end;

const i:word=0;

{set rgb palette value}
procedure P(c,r,g,b: byte);
begin
  port[$3C8]:=c;
  port[$3C9]:=r;
  port[$3C9]:=g;
  port[$3C9]:=b;
end;

{set color palette}
procedure GenPalette;
var f,r,g,b:byte;
begin
 r:=191+round(sin(i/22)*64);
 g:=191+round(sin(i/33)*64);
 b:=191+round(sin(i/44)*64);
 for f:=0 to 255
 do P(f,r*f shr 10,g*f shr 10,b*f shr 10);
end;

const il=64000;
type  tImageBuffer=array[0..il-1] of byte;
      tImagePtr=^tImageBuffer;
var   v:tImagePtr;

{get picture memory}
function GetImage320x200: tImagePtr;
var  ip: tImagePtr;
begin
  GetMem (ip, il);
  GetImage320x200 := ip;
  FillChar(ip^,il,0);
end;

{free picture memory}
procedure FreeImage320x200 (ip: tImagePtr);
begin
  if ip <> nil then FreeMem (ip, il);
end;

{Bump-Lightning-Animation}
procedure BL (var s,d: tImageBuffer);
var lx,ly,p,vy,di,x,y:integer;
begin
 lx:=160+round(cos(i/15)*33);
 ly:=100+round(sin(i/19)*44);
 inc(i); p:=319;
 for y:=198 downto 1 do begin
  inc(p,2); vy:=ly-y;
  for x:=1 to 318 do begin inc(p);
   di:=abs(vy+s[p-320]-s[p+320])
      +abs(lx-x+s[p+1]-s[p-1]);
   if di>255 then d[p]:=0
   else d[p]:=255-di;
  end;
 end;
end;

{create piicture with random values}
procedure GenPicture (s: tImagePtr);
var   i: word;
begin
  for i:=0 to il-1 do s^[i]:=random(30);
end;

{draw random rectangles}
procedure RPix (s: tImagePtr);
var   i,j,c, x,y:word;
begin
  i := random (311);
  j := random (193);
  c := 20+random (40);
  for x := i to i+8
  do for y := j to j + 6
  do s^[y*320+x] := c;
end;

const cb: char =#0;
var   li: word; img1: tImagePtr;
begin
  v := ptr(segA000,0);
  asm mov ax,19; int 16; end;
  img1 := GetImage320x200;
  GenPicture (img1);
  repeat
    for li := 1 to 20 { acceleration, because}
    do begin          { KeyPressed-check is slow}
      GenPalette;
      RPIX (img1);
      BL (img1^, v^);
    end;
    if keypressed then cb := readkey;
  until cb = #27;
  asm mov ax,3; int 16; end;
end.
